                                                        /* PROTOTYP.H */
#ifndef __CSOUND_PROTO_H
#define __CSOUND_PROTO_H

#include <stdlib.h>
#define IGN(X) X = X

#include "memalloc.h"

#ifndef CSOUND_API_HEADERS

#ifdef __cplusplus
extern "C" {
#endif

int     hetro(int argc, char **argv), lpanal(int argc, char **argv);
int     pvanal(int argc, char **argv), cvanal(int argc, char **argv);
int     sndinfo(int argc, char **argv), pvlook(int argc, char **argv);
int     dnoise(int argc, char **argv);
void    cscorinit(void), cscore(void);
char    *mmalloc(long), *mcalloc(long);
void    *mrealloc(void*, long), mfree(void*);
void    auxalloc(long, AUXCH *);
void    fdrecord(FDCH *), fdclose(FDCH *), fdchclose(INSDS *);
void    warning(char *), initerror(char *), perferror(char *);
void    synterr(char *), synterrp(char *, char *);
void    die(char *), dies(char *, char *);
void    putop(TEXT *), putstrg(char *);
void    rdorchfile(void), otran(void), resetouts(void);
char    argtyp(char *);
TEXT    *getoptxt(int *);
int     express(char *), getopnum(char *), pnum(char *), lgexist(char *);
void    oload(void);
void    cpsoctinit(void), reverbinit(void);
void    dispinit(void);
void    sssfinit(void);
int     init0(void);
INSDS   *instance(int);
int     isfullpath(char *), dispexit(void);
char    *catpath(char *, char *);
int     openin(char *), openout(char *, int);
void    scsort(FILE *, FILE *);
int     scxtract(FILE *, FILE *, FILE *);
int     rdscor(EVTBLK *);
int     musmon(void);
void    RTLineset(void);
int     sensLine(void);
void    fgens(EVTBLK *);
FUNC    *ftfind(MYFLT*), *ftnp2find(MYFLT*), *ftfindp(MYFLT *argp);
MEMFIL  *ldmemfile(char *);
void    csBeep(void), rlsmemfiles(void);
double  modf(double, double *);         /* not included in math.h */
MYFLT   intpow(MYFLT, long);
void    list_opcodes(int);
void    dbfs_init(float dbfs);
void    dribble_printf(const char *fmt, ...);
void    err_printf(const char *fmt, ...);
#define printf dribble_printf
#ifdef WIN32
char    *mytmpnam(char *);
#define tmpnam mytmpnam
#endif
                                        /* common globals */
#define sstrcod SSTRCOD
extern char *unquote(char *);

#define CSGLOBAL(x)     cglob.x

#ifndef CS_H_NO_MACROS_FOR_GLOBALS

#define ksmps           CSGLOBAL(csglobals).ksmps
#define global_ksmps    CSGLOBAL(csglobals).global_ksmps
#define ensmps          CSGLOBAL(csglobals).ensmps
#define global_ensmps   CSGLOBAL(csglobals).global_ensmps
#define ekr             CSGLOBAL(csglobals).ekr
#define global_ekr      CSGLOBAL(csglobals).global_ekr
#define onedkr          CSGLOBAL(csglobals).onedkr
#define global_onedkr   CSGLOBAL(csglobals).global_onedkr
#define hfkprd          CSGLOBAL(csglobals).hfkprd
#define global_hfkprd   CSGLOBAL(csglobals).global_hfkprd
#define kicvt           CSGLOBAL(csglobals).kicvt
#define global_kicvt    CSGLOBAL(csglobals).global_kicvt
#define kcounter        CSGLOBAL(csglobals).kcounter
#define global_kcounter CSGLOBAL(csglobals).global_kcounter
#define esr             CSGLOBAL(csglobals).esr
#define onedsr          CSGLOBAL(csglobals).onedsr
#define sicvt           CSGLOBAL(csglobals).sicvt
#define tpidsr          CSGLOBAL(csglobals).tpidsr
#define mpidsr          CSGLOBAL(csglobals).mpidsr
#define mtpdsr          CSGLOBAL(csglobals).mtpdsr
#define e0dbfs          CSGLOBAL(csglobals).e0dbfs
#define nchnls          CSGLOBAL(csglobals).nchnls
#define nspin           CSGLOBAL(csglobals).nspin
#define nspout          CSGLOBAL(csglobals).nspout
#define spoutactive     CSGLOBAL(csglobals).spoutactive
#define spin            CSGLOBAL(csglobals).spin
#define spout           CSGLOBAL(csglobals).spout
#define zklast          CSGLOBAL(csglobals).zklast
#define zalast          CSGLOBAL(csglobals).zalast
#define zkstart         CSGLOBAL(csglobals).zkstart
#define zastart         CSGLOBAL(csglobals).zastart
#define curip           CSGLOBAL(csglobals).curip
#define ids             CSGLOBAL(csglobals).ids
#define pds             CSGLOBAL(csglobals).pds
#define reinitflag      CSGLOBAL(csglobals).reinitflag
#define tieflag         CSGLOBAL(csglobals).tieflag

#define nlabels         CSGLOBAL(nlabels)
#define ngotos          CSGLOBAL(ngotos)
#define strsets         CSGLOBAL(csglobals).strsets
#define strsmax         CSGLOBAL(csglobals).strsmax
#define peakchunks      CSGLOBAL(peakchunks)
#define currevent       CSGLOBAL(currevent)
#define keep_tmp        CSGLOBAL(keep_tmp)
#define dither_output   CSGLOBAL(dither_output)
#define opcodlst        CSGLOBAL(opcodlst)
#define opcode_list     CSGLOBAL(opcode_list)   /* IV - Oct 31 2002 */
#define oplstend        CSGLOBAL(oplstend)
#define dribble         CSGLOBAL(dribble)
#define holdrand        CSGLOBAL(holdrand)
#define maxinsno        CSGLOBAL(maxinsno)
#define maxopcno        CSGLOBAL(maxopcno)      /* IV - Oct 24 2002 */
#define Linevtblk       CSGLOBAL(Linevtblk)
#define nrecs           CSGLOBAL(nrecs)
#define Linepipe        CSGLOBAL(Linepipe)
#define Linefd          CSGLOBAL(Linefd)
#define ls_table        CSGLOBAL(ls_table)
#define curr_func_sr    CSGLOBAL(curr_func_sr)
#define retfilnam       CSGLOBAL(retfilnam)
#define orchname        CSGLOBAL(orchname)
#define scorename       CSGLOBAL(scorename)
#define xfilename       CSGLOBAL(xfilename)
#define instrtxtp       CSGLOBAL(instrtxtp)
#define errmsg          CSGLOBAL(errmsg)
#define scfp            CSGLOBAL(scfp)
#define oscfp           CSGLOBAL(oscfp)
#define maxamp          CSGLOBAL(maxamp)
#define smaxamp         CSGLOBAL(smaxamp)
#define omaxamp         CSGLOBAL(omaxamp)
#define maxampend       CSGLOBAL(maxampend)
#define maxpos          CSGLOBAL(maxpos)
#define smaxpos         CSGLOBAL(smaxpos)
#define omaxpos         CSGLOBAL(omaxpos)
#define ssdirpath       CSGLOBAL(ssdirpath)
#define sfdirpath       CSGLOBAL(sfdirpath)
#define tokenstring     CSGLOBAL(tokenstring)
#define polish          CSGLOBAL(polish)
#define SCOREIN         CSGLOBAL(scorein)
#define SCOREOUT        CSGLOBAL(scoreout)
#define pool            CSGLOBAL(pool)
#define ARGOFFSPACE     CSGLOBAL(argoffspace)
#define frstoff         CSGLOBAL(frstoff)
#define sensType        CSGLOBAL(sensType)
#define frstbp          CSGLOBAL(frstbp)
#define sectcnt         CSGLOBAL(sectcnt)
#define M_CHNBP         CSGLOBAL(m_chnbp)
#define cpsocint        CSGLOBAL(cpsocint)
#define cpsocfrc        CSGLOBAL(cpsocfrc)
#define inerrcnt        CSGLOBAL(inerrcnt)
#define synterrcnt      CSGLOBAL(synterrcnt)
#define perferrcnt      CSGLOBAL(perferrcnt)
#define MIDIoutDONE     CSGLOBAL(MIDIoutDONE)
#define midi_out        CSGLOBAL(midi_out)
#define strmsg          CSGLOBAL(strmsg)
#define instxtanchor    CSGLOBAL(instxtanchor)
#define actanchor       CSGLOBAL(actanchor)
#define rngcnt          CSGLOBAL(rngcnt)
#define rngflg          CSGLOBAL(rngflg)
#define multichan       CSGLOBAL(multichan)
#define OrcTrigEvts     CSGLOBAL(OrcTrigEvts)
#define name_full       CSGLOBAL(name_full)
#define Mforcdecs       CSGLOBAL(Mforcdecs)
#define Mxtroffs        CSGLOBAL(Mxtroffs)
#define MTrkend         CSGLOBAL(MTrkend)
#define tran_sr         CSGLOBAL(tran_sr)
#define tran_kr         CSGLOBAL(tran_kr)
#define tran_ksmps      CSGLOBAL(tran_ksmps)
#define tran_0dbfs      CSGLOBAL(tran_0dbfs)
#define tran_nchnls     CSGLOBAL(tran_nchnls)
#define sadirpath       CSGLOBAL(sadirpath)
#define opcodeInfo      CSGLOBAL(opcodeInfo)    /* IV - Oct 20 2002 */
#define instrumentNames CSGLOBAL(instrumentNames)
#define dbfs_to_short   CSGLOBAL(dbfs_to_short)
#define short_to_dbfs   CSGLOBAL(short_to_dbfs)
#define dbfs_to_float   CSGLOBAL(dbfs_to_float)
#define float_to_dbfs   CSGLOBAL(float_to_dbfs)
#define dbfs_to_long    CSGLOBAL(dbfs_to_long)
#define long_to_dbfs    CSGLOBAL(long_to_dbfs)
#define rtin_dev        CSGLOBAL(rtin_dev)
#define rtout_dev       CSGLOBAL(rtout_dev)
#define MIDIINbufIndex  CSGLOBAL(MIDIINbufIndex)
#define MIDIINbuffer2   CSGLOBAL(MIDIINbuffer2)
#define exitjmp         CSGLOBAL(exitjmp)

#define initerror(x)    ((CSOUNDAPI*) &cglob)->InitError((void*) &cglob, x)
#define perferror(x)    ((CSOUNDAPI*) &cglob)->PerfError((void*) &cglob, x)
#define die(x)          ((CSOUNDAPI*) &cglob)->Die((void*) &cglob, x)

#endif          /* !CS_H_NO_MACROS_FOR_GLOBALS */

#ifdef __cplusplus
}
#endif

#endif          /* !CSOUND_API_HEADERS */

#endif          /* !__CSOUND_PROTO_H */

