#include "cs.h"                 /*                              OLOAD.C   */
#include "oload.h"
#include <math.h>       /* IV - Feb 18 2002 */
#include "insert.h"

#define DKEY_DFLT  60

static  MYFLT   *gbloffbas;

        int     pnum(char*);
extern  void    cpsoctinit(void), reverbinit(void), sssfinit(void);

/* RWD for reentry */
void oloadRESET(void)
{
    INSTRTXT    *tp = instxtanchor.nxtinstxt;

    memset(&instxtanchor,0,sizeof(INSTRTXT));
    ARGOFFSPACE = NULL;
    pool        = NULL;
    gbloffbas   = NULL;
    spin        = NULL;
    spout       = NULL;
    CSGLOBAL(O).odebug    = 0;
    /* IV - Oct 31 2002: clear instrtxtp array */
    while (tp) {
      INSTRTXT  *nxttp = tp->nxtinstxt;
      OPTXT *bp = tp->nxtop;
      INSDS *ip = tp->instance;
      while (ip) {                              /* free all instances, */
        INSDS *nxtip = ip->nxtinstance;
        if (ip->opcod_iobufs && ip->insno > maxinsno)   /* IV - Nov 10 2002 */
          mfree(ip->opcod_iobufs);
        if (ip->fdch.nxtchp) fdchclose(ip);
        if (ip->aux_heap)
          csoundHeapDestroy(&(ip->aux_heap));           /* IV - Feb 22 2003 */
        mfree(ip); ip = nxtip;
      }
      while (bp) {                              /* and opcode texts */
        OPTXT *nxtbp = bp->nxtop;
        mfree(bp); bp = nxtbp;
      }
      mfree(tp);
      tp = nxttp;
    }
    mfree(instrtxtp);           /* Start again */
    /* IV - Jan 30 2003 */
    globalsRESET((void*) &cglob);
}

void oload(void)
{
    long   n, nn, combinedsize, gblabeg, lclabeg, insno, *lp;
    MYFLT  *combinedspc, *gblspace, *fp1, *fp2;
/*     short  *pgmdim = NULL; */
    INSTRTXT *ip;
    OPTXT *optxt;
    esr = tran_sr; ekr = tran_kr;
    /* IV - Feb 18 2003 */
    ksmps = (int) ((ensmps = tran_ksmps) + FL(0.5));
    ip = instxtanchor.nxtinstxt;                /* for instr 0 optxts:  */
    optxt = (OPTXT *) ip;
    while ((optxt = optxt->nxtop) !=  NULL) {
      TEXT  *ttp = &optxt->t;
      ARGOFFS *inoffp, *outoffp;
      int opnum = ttp->opnum;
      if (opnum == ENDIN) break;
      if (opnum == LABEL) continue;
      outoffp = ttp->outoffs;           /* use unexpanded ndxes */
      inoffp = ttp->inoffs;             /* to find sr.. assigns */
      if (outoffp->count == 1 && inoffp->count == 1) {
        int rindex = (int)outoffp->indx[0] - (int)CSGLOBAL(O).poolcount;
        MYFLT conval = pool[inoffp->indx[0] - 1];
        switch(rindex) {
          case 1:  esr = conval;  break;  /* & use those values */
          case 2:  ekr = conval;  break;  /*  to set params now */
          /* IV - Feb 18 2003 */
          case 3:  ksmps = (int) ((ensmps = conval) + FL(0.5));   break;
          case 4:  nchnls = (int) (conval + FL(0.5));  break;
          case 5:  e0dbfs = conval; break;
          default: break;
        }
      }
    }
    /* why I want oload() to return an error value.... */
    if(e0dbfs <= 0.0)
      die(Str("bad value for 0dbfs: must be positive."));
    VMSG( printf("esr = %7.1f, ekr = %7.1f, ksmps = %d, nchnls = %d 0dbfs = %.1f\n",
                 esr ,ekr, ksmps, nchnls, e0dbfs); ) ;
    if (CSGLOBAL(O).sr_override) {  /* if command-line overrides, apply now */
      esr = (MYFLT)CSGLOBAL(O).sr_override;
      ekr = (MYFLT)CSGLOBAL(O).kr_override;
      /* IV - Feb 18 2003 */
      ksmps = (int) ((ensmps = (MYFLT)(CSGLOBAL(O).sr_override
                                       / CSGLOBAL(O).kr_override)) + FL(0.5));
      printf("sample rate overrides: esr = %7.1f, ekr = %7.1f, ksmps = %d\n",
             esr, ekr, ksmps);
    }
    combinedsize = (CSGLOBAL(O).poolcount + CSGLOBAL(O).gblfixed
                    + CSGLOBAL(O).gblacount * ksmps)
                   * sizeof(MYFLT);
    combinedspc = (MYFLT *)mcalloc((long)combinedsize);
    for (fp1 = pool, fp2 = combinedspc, nn = CSGLOBAL(O).poolcount; nn--; )
      *fp2++ = *fp1++;              /* copy pool into combined space */
    mfree((void *)pool);
    pool = combinedspc;
    gblspace = pool + CSGLOBAL(O).poolcount;
    gblspace[0] = esr;              /*   & enter        */
    gblspace[1] = ekr;              /*   rsvd word      */
    gblspace[2] = ensmps;           /*   curr vals  */
    gblspace[3] = (MYFLT)nchnls;
    gblspace[4] = e0dbfs;
    gbloffbas = pool - 1;

    gblabeg = CSGLOBAL(O).poolcount + CSGLOBAL(O).gblfixed + 1;
    ip = &instxtanchor;
    while ((ip = ip->nxtinstxt) != NULL) {      /* EXPAND NDX for A Cells */
      optxt = (OPTXT *) ip;                     /*   (and set localen)    */
      lclabeg = (long)(ip->pmax + ip->lclfixed + 1);
      VMSG( printf("lclabeg %ld\n",lclabeg); ) ;
      /* IV - Feb 22 2003: calculate local data size */
      ip->localen = ((long) ip->lclfixed + (long) ip->lclacnt * (long) ksmps)
                    * (long) sizeof(MYFLT);
      ip->localen = (long) OPDS_ALIGN(ip->localen);     /* with alignment */
      for (insno=0, n=0; insno <= maxinsno; insno++)
        if (instrtxtp[insno] == ip)  n++;              /* count insnos  */
      lp = ip->inslist = (long *) mmalloc((long)(n+1) * sizeof(long));
      for (insno=0; insno <= maxinsno; insno++)
        if (instrtxtp[insno] == ip)  *lp++ = insno;    /* creat inslist */
      *lp = -1;                                        /*   & terminate */
      insno = *ip->inslist;                            /* get the first */
      while ((optxt = optxt->nxtop) !=  NULL) {
        TEXT *ttp = &optxt->t;
        ARGOFFS *aoffp;
        long  indx;
        long posndx;
        int *ndxp;
        int opnum = ttp->opnum;
        if (opnum == ENDIN || opnum == ENDOP) break;    /* IV - Sep 8 2002 */
        if (opnum == LABEL) continue;
        aoffp = ttp->outoffs;
        n=aoffp->count;
        for (ndxp=aoffp->indx; n--; ndxp++) {
/*        printf("**** indx = %d (%x); gblabeg=%d lclabeg=%d\n",
                 *ndxp, *ndxp, gblabeg, lclabeg ); */
          if ((indx = *ndxp) > gblabeg) {
            indx = gblabeg + (indx - gblabeg) * ksmps;
          }
          else if (indx <= 0 && (posndx = -indx) > lclabeg
                   && indx >= LABELIM) {
            indx = -(lclabeg + (posndx - lclabeg) * ksmps);
          }
          else if (indx > 0 && indx <= 3 && CSGLOBAL(O).sr_override
                   && ip == instxtanchor.nxtinstxt) { /* for instr 0 */
            indx += 3;    /* deflect any old sr, kr, ksmps targets */
          }
          else continue;
          *ndxp = (int) indx;
        }
        aoffp = ttp->inoffs;            /* inargs:                  */
        if (opnum >= SETEND) goto realops;
        switch(opnum) {                 /*      do oload SETs NOW  */
        case STRSET:
          if (strsets == NULL)
            strsets = (char **)
              mcalloc((long)((strsmax=STRSMAX)+1) * sizeof(char *));
          indx = (long)gbloffbas[*aoffp->indx];
          if (indx >= strsmax) {
            long newmax = strsmax + STRSMAX;
            int i;
            while (indx > newmax) newmax += STRSMAX;
            strsets = (char**)mrealloc(strsets, (newmax+1)*sizeof(char *));
            /* ??? */
            for (i=strsmax; i<newmax+1; i++) strsets[i] = NULL;
            strsmax = newmax;
          }
          if (strsets == NULL || indx < 0) { /* No space left or -ve index */
            warning(Str("illegal strset index"));
            longjmp(exitjmp,1);
          }
          if (strsets[indx] != NULL)
            warning(Str("strset index conflict"));
          else {
            strsets[indx] = ttp->strargs[0];
          }
          printf("Strsets[%d]:%s\n", indx, strsets[indx]);
          break;
        case PSET:
          printf("PSET: isno=%d, pmax=%d\n", insno, ip->pmax);
          if ((n = aoffp->count) != ip->pmax) {
            sprintf(errmsg,Str("i%ld pset args != pmax"), insno);
            warning(errmsg);
            if (n < ip->pmax) n = ip->pmax; /* cf pset, pmax    */
          }                                   /* alloc the larger */
          ip->psetdata = (MYFLT *) mcalloc((long)n * sizeof(MYFLT));
          for (n=aoffp->count,fp1=ip->psetdata,ndxp=aoffp->indx;
               n--; ) {
            *fp1++ = gbloffbas[*ndxp++];
            printf("..%f..", *(fp1-1));
          }
          printf("\n");
          break;
        }

        continue;       /* no runtime role for the above SET types */

      realops:
        n = aoffp->count;
        for (ndxp=aoffp->indx; n--; ndxp++) {
/*        printf("**** indx = %d (%x)\n", *ndxp, *ndxp); */
          if ((indx = (long)*ndxp) > gblabeg) {
            indx = gblabeg + (indx - gblabeg) * ksmps;
          }
          else if (indx <= 0 && (posndx = -indx) > lclabeg
                   && indx >= LABELIM) {
            indx = -(lclabeg + (posndx - lclabeg) * ksmps);
          }
          else continue;
          *ndxp = (int) indx;
        }
      }
      /* on Mac/Win, allow system events */
      if (!POLL_EVENTS()) longjmp(exitjmp, 1);
    }

    if ((nn = init0()) > 0)                             /* run instr 0 inits */
      die(Str("header init errors"));
    /* IV - Feb 18 2003 */
    {
#ifdef MYFLT_IS_FLOAT
      double    max_err = 1.0e-6;
#else
      double    max_err = 1.0e-12;
#endif
      sprintf(errmsg, "sr = %f, kr = %f, ksmps = %f\n", /* & chk consistency */
              gblspace[0], gblspace[1], gblspace[2]);   /*   one more time   */
      if (ksmps < 1 ||
          fabs(((double) gblspace[2] / (double) ksmps) - 1.0) > max_err) {
        strcat(errmsg, "error: invalid ksmps value");
        ((CSOUNDAPI*) &cglob)->Die((void*) &cglob, errmsg);
        return;
      }
      gblspace[2] = ensmps = (MYFLT) ksmps;
      if (gblspace[0] <= FL(0.0)) {
        strcat(errmsg, "error: invalid sample rate");
        ((CSOUNDAPI*) &cglob)->Die((void*) &cglob, errmsg);
        return;
      }
      if (gblspace[1] <= FL(0.0)) {
        strcat(errmsg, "error: invalid control rate");
        ((CSOUNDAPI*) &cglob)->Die((void*) &cglob, errmsg);
        return;
      }
      if (fabs(((double) gblspace[0]
                / ((double) gblspace[1] * (double) gblspace[2])) - 1.0)
          > max_err) {
        strcat(errmsg, "error: inconsistent sr, kr, ksmps");
        ((CSOUNDAPI*) &cglob)->Die((void*) &cglob, errmsg);
        return;
      }
    }

    tpidsr = TWOPI_F / esr;                             /* now set internal  */
    mtpdsr = -tpidsr;                                   /*    consts         */
    mpidsr = -PI_F / esr;
    sicvt = FMAXLEN / esr;
    kicvt = FMAXLEN / ekr;
    hfkprd = FL(0.5) / ekr;
    onedsr = FL(1.0) / esr;
    onedkr = FL(1.0) / ekr;
    /* IV - Sep 8 2002: save global variables that depend on ksmps */
    global_ksmps = ksmps; global_ensmps = ensmps; global_ekr = ekr;
    global_onedkr = onedkr; global_hfkprd = hfkprd; global_kicvt = kicvt;
    global_kcounter = kcounter;
    cpsoctinit();
    reverbinit();
    sssfinit();
    dbfs_init((float) e0dbfs);
    nspin = nspout = ksmps * nchnls;                    /* alloc spin & spout */
    spin =  (MYFLT *) mcalloc((long) nspin * sizeof(MYFLT));
    spout = (MYFLT *) mcalloc((long) nspout * sizeof(MYFLT));
}

INSDS *
instance(int insno)             /* create instance of an instr template */
                                /*   allocates and sets up all pntrs    */
{
    INSTRTXT *tp;
    INSDS   *ip;
    OPTXT   *optxt;
    OPDS    *opds, *prvids, *prvpds, **prvddsp, **prvsdsp;
    OENTRY  *ep;
    LBLBLK  **lopds, **lopdsp;
    LARGNO  *larg, *largp/* = larg */;
    int     n, pextent, opnum, reqd;
    uintptr_t   nxtopds, opdslim;
    MYFLT   **argpp, *fltp, *lclbas, *lcloffbas;
    ARGOFFS *aoffp;
    int     indx;
    int     *ndxp;
    MCHNBLK *chp = NULL;

    lopds = (LBLBLK**) mmalloc(sizeof(LBLBLK*) * nlabels);
    lopdsp = lopds;
    larg = (LARGNO*) mmalloc(sizeof(LARGNO) * ngotos);
    largp = larg;
    lopdsp = lopds;
    tp = instrtxtp[insno];
    /* IV - Feb 22 2003 */
    if (tp->threads & 0x40) {               /* if need midi chan, chk ok */
      MCHNBLK **chpp = M_CHNBP;
      for (n = MAXCHAN; n--; ) {
        if ((chp = *chpp++) != ((MCHNBLK*) NULL)) {
          if (!chp->insno) {
            chp->insno = insno;
            printf(Str("instr %d seeking midi chnl data, assigned chnl %d\n"),
                   insno, chp->insno);
            break;
          }
          if (chp->insno != insno)
            continue;
        }
      }
    }
    pextent = (int) sizeof(INSDS) + (int) tp->pextrab;  /* alloc new space,  */
    ip = (INSDS *) mcalloc((long) pextent + tp->localen + tp->opdstot
                           + OPDS_ALIGN_VALUE);
    ip->csound = (void*) &cglob;                        /* IV - Feb 22 2003 */
    ip->csglobals = (void*) &(cglob.csglobals);
    /* IV - Feb 22 2003 */
    if (tp->threads & 0x40)
        ip->m_chnbp = chp;
    /* IV - Oct 26 2002: replaced with faster version (no search) */
    ip->prvinstance = tp->lst_instance;
    if (tp->lst_instance)
      tp->lst_instance->nxtinstance = ip;
    else
      tp->instance = ip;
    tp->lst_instance = ip;
    /* IV - Nov 10 2002 */
    if (insno > maxinsno) {
      int pcnt;
      ip->nxtact = tp->act_instance;        /* next free instance for */
      tp->act_instance = ip;                /* user opcodes */
      pcnt = (int) tp->opcode_info->perf_incnt;
      pcnt += (int) tp->opcode_info->perf_outcnt;
      pcnt = sizeof(OPCOD_IOBUFS) + sizeof(MYFLT*) * (pcnt << 1);
      ip->opcod_iobufs = (void*) mmalloc(pcnt);
    }
    lcloffbas = &ip->p0;
    /* IV - Feb 22 2003: split local space */
    nxtopds = (uintptr_t) ip;
    nxtopds = OPDS_ALIGN(nxtopds + (uintptr_t) pextent);        /* align */
    lclbas = (MYFLT*) nxtopds;
    nxtopds += (uintptr_t) tp->localen;
    opdslim = nxtopds + (uintptr_t) tp->opdstot;
    VMSG( printf(Str("instr %d allocated at %p\n\tlclbas %p, opds %p\n"),
                     insno, (void*) ip, (void*) lclbas, (void*) nxtopds); )
    optxt = (OPTXT *)tp;
    prvids = prvpds = (OPDS *)ip;
    /* IV - Feb 22 2003: pointers to chains of destructor functions */
    prvddsp = &(ip->nxtd); prvsdsp = &(ip->nxts);
    while ((optxt = optxt->nxtop) != NULL) {     /* for each op in instr */
      TEXT *ttp = &optxt->t;
      if ((opnum = ttp->opnum) == ENDIN           /*  (until ENDIN)  */
          || opnum == ENDOP)      /* IV - Sep 8 2002: (or ENDOP) */
        break;
      ep = &opcodlst[opnum];                      /* for all ops:     */
      opds = (OPDS *) nxtopds;                    /*   take reqd opds */
      /* IV - Feb 22 2003: allocate OPDSX structure if d- or s-rate */
      /* threads requested */
      if ((int) ep->thread & 0x30) {
        opds = (OPDS*) OPDS_ALIGN((uintptr_t) opds + (uintptr_t) sizeof(OPDSX));
        opds->opds_ex = (OPDSX*) nxtopds;
        nxtopds = (uintptr_t) opds;
      }
      else
        opds->opds_ex = NULL;
      nxtopds += (uintptr_t) OPDS_ALIGN(ep->dsblksiz);
      /* IV - Feb 22 2003 */
      if (opnum == STRSET)
        continue; /* Only at load time */
      if (opnum == PSET) {
        ip->p1 = (MYFLT) insno; continue;
      }

      VMSG( printf(Str("op %d (%s) allocated at %p\n"),
                   opnum, ep->opname, opds); )
      opds->optext = optxt;                       /* set common headata */
      opds->insdshead = ip;
      /* IV - Feb 08 2003: pointer to globals structure of owner */
      /* Csound instance */
      opds->globals = &(cglob.csglobals);
      if (opnum == LABEL) {                     /* LABEL:       */
        LBLBLK  *lblbp = (LBLBLK *) opds;
        lblbp->prvi = prvids;                   /*    save i/p links */
        lblbp->prvp = prvpds;
        *lopdsp++ = lblbp;                      /*    log the lbl bp */
        continue;                               /*    for later refs */
      }
      if (ep->thread & 0x10) {    /* IV - Feb 22 2003: thread 16 (d) */
        if (ep->dopadr == NULL) {
          die(Str("null dopadr"));
          return NULL;
        }
        *prvddsp = opds;
        prvddsp = &(opds->opds_ex->nxtd);
        opds->opds_ex->dopadr = ep->dopadr;
      }
      if (ep->thread & 0x20) {    /* IV - Feb 22 2003: thread 32 (s) */
        if (ep->dopadr == NULL) {
          die(Str("null dopadr"));
          return NULL;
        }
        *prvsdsp = opds;
        prvsdsp = &(opds->opds_ex->nxts);
        opds->opds_ex->dopadr = ep->dopadr;
      }
      if ((ep->thread & 07)==0) {                   /* thread 1 OR 2:  */
        if (ttp->pftype == 'b') {
          prvids = prvids->nxti = opds;
          opds->iopadr = ep->iopadr;
        }
        else {
          prvpds = prvpds->nxtp = opds;
          opds->opadr = ep->kopadr;
        }
        goto args;
      }
      if ((ep->thread & 01) != 0) {             /* thread 1:        */
        prvids = prvids->nxti = opds;           /* link into ichain */
        opds->iopadr = ep->iopadr;              /*   & set exec adr */
        if (opds->iopadr == NULL)
          die(Str("null iopadr"));
      }
      if ((n = ep->thread & 06) != 0) {         /* thread 2 OR 4:   */
        prvpds = prvpds->nxtp = opds;           /* link into pchain */
        if (!(n & 04) ||
            (ttp->pftype == 'k' && ep->kopadr != NULL))
          opds->opadr = ep->kopadr;             /*      krate or    */
        else opds->opadr = ep->aopadr;          /*      arate       */
        VMSG( printf("opadr = %p\n",opds->opadr); )
        if (opds->opadr == NULL)
          die(Str("null opadr"));
      }
 args:
      argpp = (MYFLT **)((char *)opds + sizeof(OPDS));
      VMSG( printf("argptrs:"); )
      aoffp = ttp->outoffs;                 /* for outarg codes: */
      reqd = strlen(ep->outypes);
      for (n=aoffp->count, ndxp=aoffp->indx; n--; reqd--) {
        if ((indx = *ndxp++) > 0)           /* cvt index to lcl/gbl adr */
          fltp = gbloffbas + indx;
        else
          fltp = lcloffbas - indx;
        VMSG( printf("\t%p", fltp); )
        *argpp++ = fltp;
      }
      while (reqd--) {                      /* if more outypes, pad */
        VMSG( printf("\tPADOUT"); )
        *argpp++ = NULL;
      }
      aoffp = ttp->inoffs;                  /* for inarg codes: */
      for (n = aoffp->count, ndxp = aoffp->indx; n--; ) {
        if ((indx = *ndxp++) < LABELIM) {
          VMSG( printf("\t***lbl"); )
          largp->lblno = indx - LABELOFS;   /* if label ref, defer */
          largp->argpp = argpp++;
          largp++;
        }
        else {
          if (indx > 0)               /* else cvt ndx to lcl/gbl */
            fltp = gbloffbas + indx;
          else
            fltp = lcloffbas - indx;
          VMSG( printf("\t%p", fltp); )
          *argpp++ = fltp;
        }
      }
      VMSG( { printf("\n"); } )
    }
    if (nxtopds != opdslim) {
      printf(Str("nxtopds = %p opdslim = %p\n"),
             (void*) nxtopds, (void*) opdslim);
      die(Str("inconsistent opds total"));
    }
    while (--largp >= larg)
      *largp->argpp = (MYFLT *) lopds[largp->lblno];    /* now label refs */
    return (ip);
}

int pnum(char *s)               /* check a char string for pnum format  */
                                /*   and return the pnum ( >= 0 )       */
{                               /* else return -1                       */
    int n;

    if (*s == 'p' || *s == 'P')
      if (sscanf(++s, "%d", &n))
        return(n);
    return(-1);
}

