
/* loop.c -- written by Istvan Varga, Feb 2003 */

#include <Csound/csdl.h>
#include "loop.h"

/* if ((indxvar += iincr) < ilimit) igoto l */

static void loop_l_i(LOOP *p)
{
    *(p->ndxvar) += *(p->incr);
    if (*(p->ndxvar) < *(p->limit))
      GLOBLS->ids = p->l->prvi;
}

/* if ((indxvar += iincr) <= ilimit) igoto l */

static void loop_le_i(LOOP *p)
{
    *(p->ndxvar) += *(p->incr);
    if (*(p->ndxvar) <= *(p->limit))
      GLOBLS->ids = p->l->prvi;
}

/* if ((indxvar += iincr) > ilimit) igoto l */

static void loop_g_i(LOOP *p)
{
    *(p->ndxvar) += *(p->incr);
    if (*(p->ndxvar) > *(p->limit))
      GLOBLS->ids = p->l->prvi;
}

/* if ((indxvar += iincr) >= ilimit) igoto l */

static void loop_ge_i(LOOP *p)
{
    *(p->ndxvar) += *(p->incr);
    if (*(p->ndxvar) >= *(p->limit))
      GLOBLS->ids = p->l->prvi;
}

/* if ((kndxvar += kincr) < klimit) kgoto l */

static void loop_l_p(LOOP *p)
{
    *(p->ndxvar) += *(p->incr);
    if (*(p->ndxvar) < *(p->limit))
      GLOBLS->pds = p->l->prvp;
}

/* if ((kndxvar += kincr) <= klimit) kgoto l */

static void loop_le_p(LOOP *p)
{
    *(p->ndxvar) += *(p->incr);
    if (*(p->ndxvar) <= *(p->limit))
      GLOBLS->pds = p->l->prvp;
}

/* if ((kndxvar += kincr) > klimit) kgoto l */

static void loop_g_p(LOOP *p)
{
    *(p->ndxvar) += *(p->incr);
    if (*(p->ndxvar) > *(p->limit))
      GLOBLS->pds = p->l->prvp;
}

/* if ((kndxvar += kincr) >= klimit) kgoto l */

static void loop_ge_p(LOOP *p)
{
    *(p->ndxvar) += *(p->incr);
    if (*(p->ndxvar) >= *(p->limit))
      GLOBLS->pds = p->l->prvp;
}

void OPCODE(loop_opcode_init) (void *csound)
{
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loopl",      0xFFBF,             0,      NULL,   NULL,
      (SUBR) NULL,      (SUBR) NULL,        (SUBR) NULL,    (SUBR) NULL);
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loople",     0xFFBF,             0,      NULL,   NULL,
      (SUBR) NULL,      (SUBR) NULL,        (SUBR) NULL,    (SUBR) NULL);
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loopg",      0xFFBF,             0,      NULL,   NULL,
      (SUBR) NULL,      (SUBR) NULL,        (SUBR) NULL,    (SUBR) NULL);
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loopge",     0xFFBF,             0,      NULL,   NULL,
      (SUBR) NULL,      (SUBR) NULL,        (SUBR) NULL,    (SUBR) NULL);

    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loopl.i",    sizeof(LOOP),       1,      "",     "iiil",
      (SUBR) loop_l_i,  (SUBR) NULL,        (SUBR) NULL,    (SUBR) NULL);
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loople.i",   sizeof(LOOP),       1,      "",     "iiil",
      (SUBR) loop_le_i, (SUBR) NULL,        (SUBR) NULL,    (SUBR) NULL);
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loopg.i",    sizeof(LOOP),       1,      "",     "iiil",
      (SUBR) loop_g_i,  (SUBR) NULL,        (SUBR) NULL,    (SUBR) NULL);
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loopge.i",   sizeof(LOOP),       1,      "",     "iiil",
      (SUBR) loop_ge_i, (SUBR) NULL,        (SUBR) NULL,    (SUBR) NULL);
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loopl.k",    sizeof(LOOP),       1,      "",     "kkkl",
      (SUBR) NULL,      (SUBR) loop_l_p,    (SUBR) NULL,    (SUBR) NULL);
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loople.k",   sizeof(LOOP),       1,      "",     "kkkl",
      (SUBR) NULL,      (SUBR) loop_le_p,   (SUBR) NULL,    (SUBR) NULL);
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loopg.k",    sizeof(LOOP),       1,      "",     "kkkl",
      (SUBR) NULL,      (SUBR) loop_g_p,    (SUBR) NULL,    (SUBR) NULL);
    ((CSOUNDAPI*) csound)->AppendOpcode(csound,
      "loopge.k",   sizeof(LOOP),       1,      "",     "kkkl",
      (SUBR) NULL,      (SUBR) loop_ge_p,   (SUBR) NULL,    (SUBR) NULL);
}

